<?php

/**************************************************************************************************************
 *
 *   CF Image Hosting Script
 *   ---------------------------------
 *
 *   Author:    codefuture.co.uk
 *   Version:   1.6
 *
 *   You can download the latest version from: http://codefuture.co.uk/projects/imagehost/
 *
 *   Copyright (c) 2010-2012 CodeFuture.co.uk
 *   This file is part of the CF Image Hosting Script.
 *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 *   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 *   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 *   OR  IN  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *
 *   You may not modify and/or remove any copyright notices or labels on the software on each
 *   page (unless full license is purchase) and in the header of each script source file.
 *
 *   You should have received a full copy of the LICENSE AGREEMENT along with
 *   Codefuture Image Hosting Script. If not, see http://codefuture.co.uk/projects/imagehost/license/.
 *
 *
 *   ABOUT THIS PAGE -----
 *   Used For:     Gallery/search Page
 *   Last edited:  30/05/2012
 *
 *************************************************************************************************************/
 
	define('cfih', 'gallery');
	include_once('./inc/cfih.php');

// check to see if this page has been hidden
	if(!$settings['SET_HIDE_GALLERY']){
		header('Location: index.php');
		exit();
	}

// setup gallery
	include_once('./lib/gallery.class.php');
	$gallery = new gallery();

	if($settings['SET_HIDE_SEARCH'] && !empty($_GET['search'])) $search = $gallery->gallerySearch($_GET['search']);

	$imgOnGalleryRow =!empty($themeSet['gallery_row_no'])?$themeSet['gallery_row_no']:$settings['SET_IMG_ROW_NO'];
	$numberGalleryRows =!empty($themeSet['gallery_rows'])?$themeSet['gallery_rows']:$settings['SET_IMG_ROWS'];
	
	$gallery->setNumberOfImagesToShow($imgOnGalleryRow*$numberGalleryRows);
	$galleryList = $gallery->galleryList();	// make gallery

// check for search
	if(isset($search)){
		if(!$search){
			$Err['searchErr'] = $search;
			$searchHeader =  '<h4 class="search">'._T("site_search_no_results").' <span class="search_for">'.$gallery->searchFor.'</span></h4><p class="search_sug">'._T("site_search_suggestions").'</p>';
		}else{
			$searchHeader = '<h4 class="search">'.sprintf(_T("site_search_results"),'<span class="search_for">'.$gallery->imagesFound.'</span>').' <span class="search_for">'.$gallery->searchFor.'</span></h4>';
		}
	}

//inline ad
	$inline_ad = (get_ad_code('gallery')?'<div class="gallery_ad">'.get_ad_code('gallery').'</div>':'');

// check gallery for images
	if(empty($galleryList) && !isset($search))
		$Err['noImage'] = _T("site_gallery_err_no_image");

// header page var
	$pageSet['id'] = 'gallery';
	$pageSet['title'] = ' - '._T("site_gallery_page_title").' '.($gallery->pageNmber);
	$pageSet['description'] = 'Free Image Hosting, Online image gallery of uploaded images';
	$pageSet['keywords'] = 'gallery, images, photos, image gallery, photo gallery, free image hosting';

 // load header
	include './header.php';

// print search Header to page if needed
	echo (isset($searchHeader)?$searchHeader:'');

// check gallery has images to list
	if(!empty($galleryList)){
		foreach($galleryList as $k=>$image){
			echo !($k % $imgOnGalleryRow)?'<ul class="gallery">':'';// start new row
?>
			<li>
				<a href="<?php echo $image['thumbLink'];?>" title="<?php echo $image['imageAlt'];?>" class="thumb" >
					<img src="<?php echo $image['thumbSmallUrl'];?>" alt="<?php echo $image['imageAlt'];?>" />
				</a>
				<h2><a href="<?php echo $image['thumbLink'];?>" title="<?php echo $image['imageAlt'];?>"><?php echo $image['imageAlt'];?></a></h2>
				<?php if($settings['SET_ALLOW_REPORT']){?>
					<div class="img_report">
						<a rel="nofollow" href="#" title="<?php echo _T("site_gallery_report_title");?>" onclick="return doconfirm('<?php echo _T("site_gallery_report_this");?>','<?php echo $image['id'];?>')">
							<?php echo _T("site_gallery_report");?>
						</a>
					</div>
				<?php } ?>
			</li>
<?php
			echo !(($k+1) % $imgOnGalleryRow)?'</ul>':'';// end row
			if(!empty($inline_ad) && !(($k+1) % $imgOnGalleryRow)){
				echo $inline_ad;
				$inline_ad='';
			}

		}// endfor 
	// end row if it was not a full row of images
		if((($k+1) % $imgOnGalleryRow))
			echo '</ul>';

		echo $gallery->pagination((!empty($themeSet['pagination_link_no'])?$themeSet['pagination_link_no']:null));
	}

// load footer
	include './footer.php';