<?php	if(!defined('cfih') or !cfih) exit("Direct access not permitted.");
/**************************************************************************************************************
 *
 *   CF Image Hosting Script
 *   ---------------------------------
 *
 *   Author:    codefuture.co.uk
 *   Version:   1.6
 *
 *   You can download the latest version from: http://codefuture.co.uk/projects/imagehost/
 *
 *   Copyright (c) 2010-2012 CodeFuture.co.uk
 *   This file is part of the CF Image Hosting Script.
 *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 *   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 *   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 *   OR  IN  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *
 *   You may not modify and/or remove any copyright notices or labels on the software on each
 *   page (unless full license is purchase) and in the header of each script source file.
 *
 *   You should have received a full copy of the LICENSE AGREEMENT along with
 *   Codefuture Image Hosting Script. If not, see http://codefuture.co.uk/projects/imagehost/license/.
 *
 *
 *   ABOUT THIS PAGE -----
 *   Used For:     Web site Header
 *   Last edited:  30/05/2012
 *
 *************************************************************************************************************/
// check if admin is login
	if($checklogin = checklogin()){
		add_code_line('header','<link rel="stylesheet" href="'.$settings['SET_SITEURL'].'/css/adminbar.css" type="text/css" />');
		$adminMenu ='<div id="admin_bar">
		<div class="title">Admin Menu</div>
		<ul class="nav">
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php?act=logout" title="'._T("admin_menu_logout").'">'._T("admin_menu_logout").'</a></li>
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php?act=set" title="'._T("admin_menu_settings").'">'._T("admin_menu_settings").'</a></li>
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php?act=ban" title="'._T("admin_menu_banned").'">'._T("admin_menu_banned").'</a></li>
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php?act=db" title="'._T("admin_menu_database").'">'._T("admin_menu_database").'</a></li>
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php?act=images" title="'._T("admin_menu_image_list").'">'._T("admin_menu_image_list").'</a></li>
			<li><a href="'.$settings['SET_SITEURL'].'/admin.php" title="'._T("admin_menu_home").'">'._T("admin_menu_home").'</a></li>
		</ul>
	</div>';
	}

// 404 page error
	if (isset($_GET['err']))
		$Err['page_error'] = error_header($_GET['err']);

// check for errors coming from other pages
	if(isset($_SESSION['err'])){
		if(isset($Err)) $Err = array_merge($_SESSION['err'],$Err);
		else $Err = $_SESSION['err'];
		unset($_SESSION['err']);
	}

// header page var
	$pageSet['id']			= (isset($pageSet['id']) && !empty($pageSet['id'])?$pageSet['id']:'home');
	$pageSet['title']		= (isset($pageSet['title']) && !empty($pageSet['title'])?$pageSet['title']:'');
	$pageSet['description']	= (isset($pageSet['description']) && !empty($pageSet['description'])?$pageSet['description']:'Free Image Hosting '.$pageSet['title'].' - powered by CF Image Hosting');
	$pageSet['keywords']	= (isset($pageSet['keywords']) && !empty($pageSet['keywords'])?$pageSet['keywords']:'images, photos, image hosting, photo hosting, free image hosting');

?>
<!doctype html>
<html lang="<?php echo _T("site_lang_code");?>">
<head>
	<meta charset="<?php echo _T("site_charset");?>">
	<meta http-equiv="X-UA-Compatible" content="IE=8,chrome=1" />
	<title><?php echo $settings['SET_TITLE'];?><?php echo $pageSet['title'];?></title>
	<meta name="description" content="<?php echo $pageSet['description'];?>" />
	<meta name="keywords" content="<?php echo $pageSet['keywords'];?>"/>
	<meta name="robots" content="index,follow"/>
	<link href="<?php echo $settings['SET_SITEURL'];?>/favicon.ico" rel="icon" type="image/x-icon" />
	<link rel="alternate" type="application/rss+xml" title="<?php echo $settings['SET_TITLE'];?> Feed" href="<?php echo $settings['SET_SITEURL'];?>/feed.php" />
	<link rel="stylesheet" href="<?php echo $settings['SET_SITEURL'];?>/themes/<?php echo $settings['SET_THEME'];?>/<?php echo $settings['SET_THEME'];?>.css?v=<?php echo $settings['SET_VERSION'];?>" type="text/css" />
	<?php exec_action('header');?>
</head>
<body id="<?php echo $pageSet['id'];?>">
<?php echo (isset($adminMenu)?$adminMenu:''); ?>
<div id="wrap">
	<div id="header" class="clear">
		<div id="logo">
			<h1><a href="<?php echo $settings['SET_SITEURL'];?>/index.php" title="<?php echo $settings['SET_TITLE'];?> <?php echo _T("site_menu_home");?>"><?php echo $settings['SET_TITLE'];?></a></h1>
			<h2><?php echo $settings['SET_SLOGAN'];?></h2>
		</div>

<?php	if ($listLanguages = listLanguages()){?>
		<div class="languages"<?php if(!isset($theme['listLanguagesOver'])){ ?> onMouseOver="document.getElementById('language').style.display='block'" onMouseOut="document.getElementById('language').style.display='none'"<?php } ?>>
			<div class="lan_on"><span><?php echo _T("site_language");?></span><img src="<?php echo $settings['SET_SITEURL'];?>/languages/<?php echo $settings['SET_LANGUAGE'];?>.png" width="23" height="15" alt="<?php echo $settings['SET_LANGUAGE'];?>" title="<?php echo $settings['SET_LANGUAGE'];?>" /></div>
			<div id="language" class="language" ><?php echo listLanguages();?></div>
			<div class="clear_both"></div>
		</div>
<?php } ?>

	<?php if($settings['SET_HIDE_SEARCH']){?>
		<div id="search">
			<form method="get" action="<?php echo $settings['SET_SITEURL'];?>/gallery.php">
				<input type="text" size="28" name="search" id="searchBox" class="text_input" onblur="if(this.value=='')value='<?php echo _T("site_search_text");?>';" onfocus="if(this.value=='<?php echo _T("site_search_text");?>')value=''" value="<?php echo _T("site_search_text");?>" /><input type="submit" value="<?php echo _T("site_search_button");?>" class="button" />
			</form>
		</div>
	<?php } ?>
		<div id="nav">
			<ul id="main-nav">
				<li><a <?php echo ($pageSet['id']=="home" ? ' class="current" ':'');?> href="<?php echo $settings['SET_SITEURL'];?>/" title="<?php echo _T("site_menu_home");?>"><?php echo _T("site_menu_home");?></a></li>
				<?php if($settings['SET_HIDE_GALLERY']){?><li><a <?php echo ($pageSet['id']=="gallery" ? ' class="current" ':'');?> href="<?php echo $settings['SET_SITEURL'];?>/gallery.php" title="<?php echo _T("site_menu_gallery");?>"><?php echo _T("site_menu_gallery");?></a></li><?php } ?>
				<?php if($settings['SET_HIDE_FAQ']){?><li><a <?php echo ($pageSet['id']=="faq_page" ? ' class="current"':'');?> href="<?php echo $settings['SET_SITEURL'];?>/faq.php" title="<?php echo _T("site_menu_faq");?>"><?php echo _T("site_menu_faq");?></a></li><?php } ?>
				<?php if($settings['SET_HIDE_TOS']){?><li><a <?php echo ($pageSet['id']=="tos_page" ? ' class="current" ':'');?> href="<?php echo $settings['SET_SITEURL'];?>/tos.php" title="<?php echo _T("site_menu_tos");?>"><?php echo _T("site_menu_tos");?></a></li><?php } ?>
				<?php if($settings['SET_HIDE_CONTACT']){?><li><a <?php echo ($pageSet['id']=="contact_page" ? ' class="current" ':'');?> href="<?php echo $settings['SET_SITEURL'];?>/contact.php" title="<?php echo _T("site_menu_contact");?>"><?php echo _T("site_menu_contact");?></a></li><?php } ?>
			</ul>
		</div>
	<div class="clear"></div>
	</div>
	<div id="content">
<?php if(get_ad_code('header')){?>
		<div class="top_ad"><?php echo get_ad_code('header');?></div>
<?php }
// check for any notes
	if(isset($Suc)) success_note($Suc); 
// check for any errors
	if(isset($Err)) error_note($Err); 
	echo '<div id="msg"></div>';
	flushNow(1);
?>